<template>
  <div
    v-if="currentOrder"
    class="order-detail-info"
  >
    <div class='order-step__misc-items'>
      <div
        class='order-step__misc-item'
        @click="toggleAccordeon('parameters')"
      >
        <button
          :class="{ closed: !accordeonItems.parameters }"
        >
          <i class="icon chevron-up" />
        </button>
        <span>Параметры</span>
      </div>
      <ExpandTransition>
        <div
          v-if="accordeonItems.parameters"
          class="accordeon-content"
        >
          <p class="text mb20">Заказ на перевозку груза по маршруту {{ currentOrder.titleGeography }}</p>
          <div class="row mb20">
            <div class="col-xs-4">
              <ObInput
                label="Дата создания заказа"
                icon="calendar"
                :readonly="true"
                :value="formatDate(currentOrder.createdAt)"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="№ договора"
                :readonly="true"
                :value="currentOrder.contractNumber"
                :link="contractLink"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Внутренний № заказа по системе Заказчика"
                :readonly="true"
                :value="currentOrder.externalNumber"
              />
            </div>
          </div>
          <div class="row mb20">
            <div class="col-xs-4">
              <ObInput
                label="Клиент"
                :readonly="true"
                :value="currentOrder.clientTitle"
                :link="clientLink"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Контактное лицо Заказчика"
                :readonly="true"
                :value="currentOrder.clientLogistTitle"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Контактный телефон"
                :readonly="true"
                mask="+7 (999) 999-9999"
                :value="currentOrder.clientLogistPhone"
              />
            </div>
          </div>
          <div class="row mb40">
            <div class="col-xs-4">
              <ObInput
                label="Исполнитель"
                :readonly="true"
                :value="currentOrder.contractorTitle"
                :link="contractorLink"
              />
            </div>

            <div class="col-xs-4">
              <ObInput
                label="Ответственный логист Исполнителя"
                :readonly="true"
                :value="currentOrder.logistTitle"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                  label="Контактный телефон"
                  :readonly="true"
                  mask="+7 (999) 999-9999"
                  :value="currentOrder.logistPhone"
              />
            </div>
          </div>
          <template v-if="order.transportationWay === 'CONTAINER' && isFirstOrder && !isCarrier">
            <div class="title">Контейнеры</div>
            <div class="d-f al-i-c mb10">
              <ObInput
                v-model="containerNumber"
                label="Добавить контейнер"
                placeholder="Введите номер контейнера"
                class="w300"
              />
              <ObButton
                label="Добавить"
                class="ml20"
                theme="secondary"
                @click="addContainer"
              />
            </div>
            <ob-select
              :value="containersValue"
              :items="containers"
              label="Номера контейнеров"
              valueExp="resourceUuid"
              display-exp="number"
              placeholder="Выберите один или несколько вариантов"
              :is-dropdown="true"
              :is-multiselect="true"
              :is-standart="true"
              :is-tagbox="true"
              class="mb40"
              @input="deleteContainer"
            />
          </template>
          <template v-if="(isFirstOrder || (['AUTO', 'TRAIN'].includes(currentOrder.species) && !['NEW', 'ON_DOER_SEARCH'].includes(currentOrder.status)))">
            <div class="title">Номера шипментов</div>
            <div class="mb40">
              <OrderShipments
                :order="currentOrder"
              />
            </div>
          </template>
          <div class="title">Контрагенты</div>
          <ObSelect
            label="Грузоотправители"
            :items="currentOrder.consignors"
            :value="currentOrder.consignors && currentOrder.consignors.map(item => item.uuid)"
            :is-dropdown="true"
            :disabled="true"
            class="mb20"
          />
          <ObSelect
            label="Грузополучатели"
            :items="currentOrder.consignees"
            :value="currentOrder.consignees && currentOrder.consignees.map(item => item.uuid)"
            :is-dropdown="true"
            :disabled="true"
            class="mb40"
          />
          <div class="title">Код и наименование груза</div>
          <ObSelect
            label="ЕТСНГ"
            :items="currentOrder.etsngs"
            :value="currentOrder.etsngs && currentOrder.etsngs.map(item => item.uuid)"
            :is-dropdown="true"
            :disabled="true"
            class="mb20"
          />
          <div class="title">Тип груза и страховая стоимость</div>
          <ObInput
            label="Тип груза"
            :value="currentOrder.cargoTypeTitle || 'Нет данных'"
            :disabled="true"
            class="mb20"
          />
          <div class="row mb20">
            <div class="col-xs-4">
              <ObInput
                label="Общий вес груза"
                type="money:1"
                :is-convert-money="false"
                sub-title="тонн"
                :value="currentOrder.cargoWeight"
                :readonly="true"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Общий объём груза"
                sub-title="м³"
                :value="currentOrder.cargoVolume"
                :readonly="true"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Кол-во паллет"
                type="money:0"
                :is-convert-money="false"
                sub-title="шт"
                :value="currentOrder.palletCount"
                :readonly="true"
              />
            </div>
          </div>
          <div class="row mb40">
            <div class="col-xs-4">
              <ObInput
                label="Страховая стоимость груза"
                type="money:2"
                :readonly="true"
                sub-title="₽"
                :value="currentOrder.cargoInsuranceCost / 100"
                :is-convert-money="false"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Cтоимость груза по накладной"
                type="money:2"
                sub-title="₽"
                value=""
              />
            </div>
            <div
              v-if="isClicar"
              class="col-xs-4"
            >
              <div class="risks-block">
                <div class="risks-block__item">
                  <div class="risks-block__title">Группа риска заказа</div>
                  <div class="risks-block__body">
                    <div class="icons">
                      <i
                        class="icon"
                        :class="getRiskClass(currentOrder.riskColor)"
                      />
                    </div>
                    <span>Группа риска {{ getNumberRisk(currentOrder.riskColor) }}</span>
                  </div>
                </div>
                <div class="risks-block__item">
                  <div class="risks-block__title">Подходящие исполнители</div>
                  <div class="risks-block__body">
                    <div class="icons">
                      <i
                        v-for="item in currentOrder.carrierRiskColors"
                        :key="item"
                        class="icon"
                        :class="getRiskClass(item)"
                      />
                    </div>
                    <span>Группа риска {{ currentOrder.carrierRiskColors && currentOrder.carrierRiskColors.map(item => getNumberRisk(item)).join('-') }}</span>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <div class="title">Требования к сервису и безопасности</div>
          <ObSelect
            label="Дополнительные требования"
            :items="currentOrder.requirements"
            :value="currentOrder.requirements && currentOrder.requirements.map(item => item.requirementUuid)"
            :is-dropdown="true"
            :disabled="true"
            display-exp="requirementTitle"
            value-exp="requirementUuid"
            class="mb40"
          />
          <div class="title">Дополнительные параметры</div>
          <div class="row mb40">
            <div class="col-xs-4">
              <ObInput
                label="Метод трекинга"
                :readonly="true"
                :pre-icon-html="iconHtml(currentOrder.needTracking)"
                :value="currentOrder.needTracking ? 'Государственная пломба' : '-'"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Класс опасности груза"
                :readonly="true"
                :value="currentOrder.isDangerous ? 'ADR' : '-'"
              />
            </div>
            <div class="col-xs-4">
              <ObInput
                label="Температурный режим груза"
                :readonly="true"
                sub-title="°C"
                :value="currentOrder.temperatureModeTitle || '-'"
              />
            </div>
          </div>
          <div class="title">Комментарий</div>
          <ObTextarea
            label="Комментарий"
            :value="currentOrder.comment"
            :readonly="true"
          />
        </div>
      </ExpandTransition>
    </div>
  </div>
</template>

<script>
import api from '@/api'
import { mapGetters } from 'vuex'
import moment from 'moment'
import ObInput from 'common-components/src/obComponents/obInput'
import OrderShipments from '@/components/Order/orderItem/details/Shipments.vue'
import ObSelect from 'common-components/src/obComponents/obSelect'
import ObTextarea from 'common-components/src/obComponents/obTextarea'
import ObButton from 'common-components/src/obComponents/obButton'
import ExpandTransition from '@/components/ExpandTransition'
import iconState from 'common-components/src/assets/icons/state_blue.svg'
import riskMixin from '@/mixins/risk-icon'
import { formatNumber } from 'common-components/src/helpers/common'

export default {
  name: 'OrderDetailInfo',
  props: {
    uuid: {
      type: String,
      default: null
    }
  },
  mixins: [
    riskMixin
  ],
  components: {
    ObInput,
    ObSelect,
    ObTextarea,
    ObButton,
    ExpandTransition,
    OrderShipments
  },
  data () {
    return {
      moment,
      accordeonItems: {
        parameters: true
      },
      containers: [],
      containerNumber: '',
      api
    }
  },
  watch: {
    'order.uuid': {
      immediate: true,
      handler () {
        if (this.currentOrder && this.currentOrder.transportationWay === 'CONTAINER') {
          this.getContainers()
        }
      }
    }
  },
  computed: {
    ...mapGetters({
      order: 'order/order',
      subOrder: 'order/subOrder',
      isClicar: 'user/isClicar',
      isClient: 'user/isClient',
      isCarrier: 'user/isCarrier',
      additionalServices: 'order/additionalServices'
    }),
    isFirstOrder () {
      return this.uuid === this.orderId
    },
    orderId () {
      return this.$route.params.id
    },
    currentOrder () {
      if (this.uuid === this.order.uuid) {
        return this.order
      } else {
        return this.subOrder[this.uuid]
      }
    },
    containersValue () {
      return this.containers.map((item) => item.resourceUuid)
    },
    contractLink () {
      return this.isClicar && this.currentOrder.contractUuid ? { name: 'contracts__detail', params: { id: this.currentOrder.contractUuid }} : null
    },
    clientLink () {
      return this.isClicar && this.currentOrder.clientUuid ? `/logdomains/agent/${this.currentOrder.clientUuid}`: null
    },
    contractorLink () {
      return this.isClicar && this.currentOrder.contractorUuid ? `/logdomains/agent/${this.currentOrder.contractorUuid}`: null
    }
  },
  methods: {
    formatNumber,
    formatDate (date, time = true) {
      let format = 'DD.MM.YYYY' + (time ? ' HH:mm' : '')
      return moment(date).format(format)
    },
    iconHtml (needTracking = null) {
      if (needTracking) {
        return `<img src="${iconState}">`
      } else {
        return null
      }
    },
    toggleAccordeon (value) {
      this.accordeonItems[value] = !this.accordeonItems[value]
    },
    async addContainer () {
      try {
        await api.orderProcess.addOrderContainer({ order: this.order, number: this.containerNumber })
        this.containerNumber = ''
        this.getContainers()
      } catch (e) {
        console.log(e)
      }
    },
    async deleteContainer (value) {
      let isDeleted = value && (value.length < this.containers.length)
      if (isDeleted) {
        let deletedUuid = this.containers.find(item => value.every(target => target.resourceUuid !== item.resourceUuid)).resourceUuid
        await api.orderProcess.deleteOrderContainer({ order: this.order, resourceUuid: deletedUuid })
        this.getContainers()
      }
    },
    async getContainers () {
      if (!this.isCarrier) {
        this.containers = await api.orderProcess.getOrderContainersList({ uuid: this.$route.params.id })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  @import "../../../../../node_modules/common-components/src/static/css/mixins";

  .order-detail-info {
    .title {
      display: flex;
      align-items: center;
      margin-bottom: 20px;
      @include font-mixin(16px, 20px, 600, $components-orderItem_detail_info_title_font_color, 0.4px);
      &__sub {
        margin-left: 10px;
        font-weight: normal;
        color: $gray-slate;
        span {
          font-size: 12px;
        }
      }
      span + span {
        margin-left: 5px;
      }
    }
    .text {
      @include font-mixin(14px, 16px, 400, $components-orderItem_detail_info_text_font_color, 0.4px);
    }
    .mb20 {
      margin-bottom: 20px;
    }
    .mb10 {
      margin-bottom: 10px;
    }
    .mb40 {
      margin-bottom: 40px;
    }
    .ml20 {
      margin-left: 20px;
    }
    .w300 {
      width: 300px;
    }

    .risks-block {
      display: flex;
      justify-content: flex-start;
      align-items: flex-start;
      padding-top: 8px;
      &__item {
        width: 50%;
      }
      &__title {
        @include font-mixin(12px, 12px, 400, $color-grey-label , 0.4px);
      }
      &__body {
        display: flex;
        justify-content: flex-start;
        align-items: center;
        margin-top: 4px;
        min-height: 21px;
        .icons {
          &:not(:empty) {
            margin-right: 7px;
          }
          .icon {
            position: relative;
            font-size: 22px;
            & + .icon {
              margin-left: -10px;
            }
            &:nth-child(1) {
              z-index: 6;
            }
            &:nth-child(2) {
              z-index: 5;
            }
            &:nth-child(3) {
              z-index: 4;
            }
            &:nth-child(4) {
              z-index: 3;
            }
          }
        }
        span {
          @include font-mixin(12px, 12px, 400, $color-text-base , 0.4px);
        }
      }
    }

    .table-block {
      border-style: solid;
      border-color: $lavender;
      border-width: 1px 1px 0 1px;
      border-radius: 3px;
      &__header {
        display: flex;
        align-items: center;
        height: 60px;
        padding: 0 20px;
        background-color: $background-color-light;
        @include font-mixin(12px, 12px, 400, $color-text-base , 0.2px);
        .icon {
          margin-right: 8px;
          font-size: 13px;
          color: $color-grey-span;
        }
        span {
          margin-left: 8px;
          margin-right: 8px;
        }
      }
      &::v-deep {
        table {
          min-width: auto;
        }
      }
    }

    .services-block {
      padding: 10px 20px;
      border: 1px solid $lavender;
      border-radius: 3px;
    }

    &::v-deep {
      .ob-selector__multi-select {
        margin-bottom: 0;
      }
      .ob-selector__dropdown-control-open {
        display: none;
      }

      .table-footer {
        display: none;
      }
    }

    .order-step__misc-item {
      padding: 0 10px;
      display: flex;
      align-items: center;
      height: 40px;
      background-color: $light-lavender;
      border-bottom: 1px solid $components-orderItem_order_step_misc_item_border-bottom;
      border-top: 1px solid $light-lavender;
      cursor: pointer;
      @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
      button {
        display: flex;
        align-items: center;
        margin-right: 8px;
        margin-top: 1px;
        border: none;
        outline: none;
        background-color: transparent;
        appearance: none;
        font-size: 16px;
        color: $color-blue-navy-blue;
        transition: all 0.2s ease-in-out;
        @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);

        .icon {
          display: inline-block;
          transform: rotate(180deg);
          font-size: 26px;
        }
      }

      & > span {
        margin-top: 1px;
      }

      .closed .icon {
        transform: rotate(90deg);
      }
    }

    .accordeon-content {
      margin-top: 40px;
      margin-bottom: 60px;
    }

    &::v-deep {
      .not-api {
        box-shadow: 0 0 5px $components-orderItem_not_api_box_shadow;
      }
    }

    .link-style {
      color: $color-blue-navy-blue;
      text-decoration: none;
    }

    .corrections-info {
      padding-top: 30px;
      text-align: center;
      &__title {
        @include font-mixin(20px, 28px, 700, $color-text-base, 0.4px);
      }
      p {
        margin-top: 20px;
        @include font-mixin(16px, 20px, 400);
      }
    }
  }

  .not-api {
    box-shadow: 0 0 5px $components-not_api_box_shadow;
  }
</style>
